// sampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "sample.h"
#include "sampleDlg.h"

#include <sys/stat.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSampleDlg dialog

CSampleDlg::CSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSampleDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSampleDlg)
	DDX_Control(pDX, IDC_LIST1, m_list);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSampleDlg, CDialog)
	//{{AFX_MSG_MAP(CSampleDlg)
	//}}AFX_MSG_MAP
    ON_COMMAND_RANGE(IDC_RADIO1, IDC_RADIO4, OnRadioCommandRange)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSampleDlg message handlers

BOOL CSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

    CheckRadioButton(IDC_RADIO1, IDC_RADIO4, IDC_RADIO4);

    ImagelistLoading();

    ColumnSetting();

    int ndx = 0;
    CFileFind finder;
    SHFILEINFO sfi; 
    BOOL bWorking = finder.FindFile("C:\\*.*");
    while (bWorking)
    {
        bWorking = finder.FindNextFile();
        SHGetFileInfo(finder.GetFilePath(), 
            0, 
            &sfi, 
            sizeof(SHFILEINFO), 
            SHGFI_DISPLAYNAME | SHGFI_TYPENAME| SHGFI_SYSICONINDEX | SHGFI_SMALLICON); 
        ndx = AddItem1(finder, sfi, ndx);
    }
    return TRUE;
}

int CSampleDlg::AddItem1(CFileFind& file, SHFILEINFO& sfi, int ndx)
{
    CString szTemp;
    CTime fTime;

    ndx = m_list.InsertItem(ndx, sfi.szDisplayName, sfi.iIcon);
  
    if(!file.IsDirectory())
    {
        szTemp.Format("%d KB", file.GetLength64()/1024);
        m_list.SetItemText(ndx, 1, szTemp);
    }

    m_list.SetItemText(ndx, 2, sfi.szTypeName);

    file.GetLastWriteTime(fTime);
    szTemp.Format("%04d-%02d-%02d %02d:%02d:%02d",
        fTime.GetYear(),
        fTime.GetMonth(),
        fTime.GetDay(),
        fTime.GetHour(),
        fTime.GetMinute(),
        fTime.GetSecond());

    m_list.SetItemText(ndx, 3, szTemp);
    return ++ndx;
}

int CSampleDlg::AddItem2(CFileFind& file, SHFILEINFO& sfi, int ndx)
{
    CString szTemp;
    CTime fTime;

    LVITEM item;
    item.mask = LVIF_TEXT | LVIF_IMAGE;
    item.iItem = ndx;
    item.iSubItem = 0;
    item.pszText = sfi.szDisplayName;
    item.iImage = sfi.iIcon;

    ndx = m_list.InsertItem(&item);
  
    if(!file.IsDirectory())
    {
        szTemp.Format("%d KB", file.GetLength64()/1024);
        m_list.SetItemText(ndx, 1, szTemp);
    }

    m_list.SetItemText(ndx, 2, sfi.szTypeName);

    file.GetLastWriteTime(fTime);
    szTemp.Format("%04d-%02d-%02d %02d:%02d:%02d",
        fTime.GetYear(),
        fTime.GetMonth(),
        fTime.GetDay(),
        fTime.GetHour(),
        fTime.GetMinute(),
        fTime.GetSecond());

    m_list.SetItemText(ndx, 3, szTemp);
    return ++ndx;
}

void CSampleDlg::ImagelistLoading()
{
    HIMAGELIST hImageList;
    SHFILEINFO sfi;
    
    hImageList = (HIMAGELIST)SHGetFileInfo((LPCSTR)"C:\\", 
        0,
        &sfi, 
        sizeof(SHFILEINFO), 
        SHGFI_SYSICONINDEX | SHGFI_SMALLICON);
    
    if(hImageList)
        m_imgShareSmall.Attach(hImageList);
    
    hImageList = (HIMAGELIST)SHGetFileInfo((LPCSTR)"C:\\", 
        0,
        &sfi, 
        sizeof(SHFILEINFO), 
        SHGFI_SYSICONINDEX | SHGFI_LARGEICON);
    
    if(hImageList)
        m_imgShareLarge.Attach(hImageList);
    
    m_list.SetImageList(&m_imgShareSmall, LVSIL_SMALL);
    m_list.SetImageList(&m_imgShareLarge, LVSIL_NORMAL);
}

void CSampleDlg::ColumnSetting()
{
    m_list.InsertColumn(0, "̸", LVCFMT_LEFT, 180);
    m_list.InsertColumn(1, "ũ", LVCFMT_RIGHT,100);
    m_list.InsertColumn(2, "", LVCFMT_LEFT, 150);
    m_list.InsertColumn(3, " ¥", LVCFMT_LEFT, 250);
}

LRESULT CSampleDlg::OnRadioCommandRange(UINT nID)
{
    switch(nID)
    {
    case IDC_RADIO1:
        m_list.ModifyStyle(LVS_TYPEMASK, LVS_ICON);
        break;
    case IDC_RADIO2:
        m_list.ModifyStyle(LVS_TYPEMASK, LVS_SMALLICON);
        break;
    case IDC_RADIO3:
        m_list.ModifyStyle(LVS_TYPEMASK, LVS_LIST);
        break;
    case IDC_RADIO4:
        m_list.ModifyStyle(LVS_TYPEMASK, LVS_REPORT);
        break;
    }
    return 0;
}